

  strcpy(keyword,"OBS_STP_N"); 
  while( (i=tpss_parse_line( fpsdf, keyword, data)) == TPSS_PL_BLANK_LINE ) { }
  switch (i) {
    case TPSS_PL_KEYWORD_MATCH:    
      printf("[%d/%d] %s='%s'",MT_TPSS,getpid(),keyword,data); 
      sscanf(data,"%ld",&(obs[nobs].OBS_STP_N));
      printf("...converts to %ld\n",obs[nobs].OBS_STP_N);
      if ( ( obs[nobs].OBS_STP_N<1 ) || ( obs[nobs].OBS_STP_N>MAX_STP_N ) ) {   
        printf("[%d/%d] FATAL: OBS_STP_N out of range\n",MT_TPSS,getpid());  
        return;
        }
      strcpy(data,"");   
      break;
    case TPSS_PL_EOF:              printf("[%d/%d] FATAL: Unexpected TPSS_PL_EOF\n",MT_TPSS,getpid());   return; break;
    case TPSS_PL_KEYWORD_MISMATCH: printf("[%d/%d] FATAL: TPSS_PL_KEYWORD_MISMATCH\n",MT_TPSS,getpid()); return; break;
    case TPSS_PL_OVERLONG_LINE:    printf("[%d/%d] FATAL: TPSS_PL_OVERLONG_LINE\n",MT_TPSS,getpid());    return; break;
    }

  strcpy(keyword,"OBS_STP_RADEC"); 
  while( (i=tpss_parse_line( fpsdf, keyword, data)) == TPSS_PL_BLANK_LINE ) { }
  switch (i) {
    case TPSS_PL_KEYWORD_MATCH:    
      printf("[%d/%d] %s='%s'",MT_TPSS,getpid(),keyword,data); 
      sscanf(data,"%d",&(obs[nobs].OBS_STP_RADEC));
      printf("...converts to %d\n",obs[nobs].OBS_STP_RADEC);
      if ( ( obs[nobs].OBS_STP_RADEC<0 ) || ( obs[nobs].OBS_STP_RADEC>1 ) ) {   
        printf("[%d/%d] FATAL: OBS_STP_RADEC out of range\n",MT_TPSS,getpid());  
        return;
        }
      strcpy(data,"");   
      break;
    case TPSS_PL_EOF:              printf("[%d/%d] FATAL: Unexpected TPSS_PL_EOF\n",MT_TPSS,getpid());   return; break;
    case TPSS_PL_KEYWORD_MISMATCH: printf("[%d/%d] FATAL: TPSS_PL_KEYWORD_MISMATCH\n",MT_TPSS,getpid()); return; break;
    case TPSS_PL_OVERLONG_LINE:    printf("[%d/%d] FATAL: TPSS_PL_OVERLONG_LINE\n",MT_TPSS,getpid());    return; break;
    }

  for ( k=1; k<=obs[nobs].OBS_STP_N; k++ ) {
    printf("[%d/%d] --- Parsing Defined Step #%d of Observation #%d ---\n",MT_TPSS,getpid(),k,nobs);

    sprintf(keyword,"OBS_STP_C1[%d]",k); 
    while( (i=tpss_parse_line( fpsdf, keyword, data)) == TPSS_PL_BLANK_LINE ) { }
    switch (i) {
      case TPSS_PL_KEYWORD_MATCH:    
        printf("[%d/%d] %s='%s'",MT_TPSS,getpid(),keyword,data); 
        sscanf(data,"%f",&(obs[nobs].OBS_STP_C1[k]));
        printf("...converts to %f\n",obs[nobs].OBS_STP_C1[k]);
        switch (obs[nobs].OBS_STP_RADEC) {
          case 0: /* AZ */
            if ( ( obs[nobs].OBS_STP_C1[k]<0.0 ) || ( obs[nobs].OBS_STP_C1[k]>=360.0 ) ) {   
              printf("[%d/%d] FATAL: OBS_STP_C1[%d] out of range\n",MT_TPSS,getpid(),k);  
              return;
              }
            break;
          case 1: /* RA */
            if ( ( obs[nobs].OBS_STP_C1[k]<0.0 ) || ( obs[nobs].OBS_STP_C1[k]>=24.0 ) ) {   
              printf("[%d/%d] FATAL: OBS_STP_C1[%d] out of range\n",MT_TPSS,getpid(),k);  
              return;
              }
            break;
          }
        strcpy(data,"");   
        break;
      case TPSS_PL_EOF:              printf("[%d/%d] FATAL: Unexpected TPSS_PL_EOF\n",MT_TPSS,getpid());   return; break;
      case TPSS_PL_KEYWORD_MISMATCH: printf("[%d/%d] FATAL: TPSS_PL_KEYWORD_MISMATCH\n",MT_TPSS,getpid()); return; break;
      case TPSS_PL_OVERLONG_LINE:    printf("[%d/%d] FATAL: TPSS_PL_OVERLONG_LINE\n",MT_TPSS,getpid());    return; break;
      }

    sprintf(keyword,"OBS_STP_C2[%d]",k); 
    while( (i=tpss_parse_line( fpsdf, keyword, data)) == TPSS_PL_BLANK_LINE ) { }
    switch (i) {
      case TPSS_PL_KEYWORD_MATCH:    
        printf("[%d/%d] %s='%s'",MT_TPSS,getpid(),keyword,data); 
        sscanf(data,"%f",&(obs[nobs].OBS_STP_C2[k]));
        printf("...converts to %f\n",obs[nobs].OBS_STP_C2[k]);
        switch (obs[nobs].OBS_STP_RADEC) {
          case 0: /* EL */
            if ( ( obs[nobs].OBS_STP_C2[k]<0.0 ) || ( obs[nobs].OBS_STP_C2[k]>=90.0 ) ) {   
              printf("[%d/%d] FATAL: OBS_STP_C2[%d] out of range\n",MT_TPSS,getpid(),k);  
              return;
              }
            break;
          case 1: /* DEC */
            if ( ( obs[nobs].OBS_STP_C2[k]<-90.0 ) || ( obs[nobs].OBS_STP_C2[k]>=+90.0 ) ) {   
              printf("[%d/%d] FATAL: OBS_STP_C2[%d] out of range\n",MT_TPSS,getpid(),k);  
              return;
              }
            break;
          }
        strcpy(data,"");   
        break;
      case TPSS_PL_EOF:              printf("[%d/%d] FATAL: Unexpected TPSS_PL_EOF\n",MT_TPSS,getpid());   return; break;
      case TPSS_PL_KEYWORD_MISMATCH: printf("[%d/%d] FATAL: TPSS_PL_KEYWORD_MISMATCH\n",MT_TPSS,getpid()); return; break;
      case TPSS_PL_OVERLONG_LINE:    printf("[%d/%d] FATAL: TPSS_PL_OVERLONG_LINE\n",MT_TPSS,getpid());    return; break;
      }

    sprintf(keyword,"OBS_STP_T[%d]",k); 
    while( (i=tpss_parse_line( fpsdf, keyword, data)) == TPSS_PL_BLANK_LINE ) { }
    switch (i) {
      case TPSS_PL_KEYWORD_MATCH:    
        printf("[%d/%d] %s='%s'",MT_TPSS,getpid(),keyword,data); 
        sscanf(data,"%ld",&(obs[nobs].OBS_STP_T[k]));
        printf("...converts to %ld\n",obs[nobs].OBS_STP_T[k]);
        if (k==1) {
          if ( (obs[nobs].OBS_STP_T[k]<0) || (obs[nobs].OBS_STP_T[k]>(obs[nobs].OBS_DUR+5) ) ) {
            printf("[%d/%d] FATAL: obs[nobs].OBS_STP_T[%d] out of range\n",MT_TPSS,getpid(),k);   
            return;
            }
          }
        if (k>1) {
          if ( (obs[nobs].OBS_STP_T[k]<(obs[nobs].OBS_STP_T[k-1]+5)) || (obs[nobs].OBS_STP_T[k]>(obs[nobs].OBS_DUR+5) ) ) {
            printf("[%d/%d] FATAL: obs[nobs].OBS_STP_T[%d] out of range\n",MT_TPSS,getpid(),k);   
            return;
            }
          }
        strcpy(data,"");   
        break;
      case TPSS_PL_EOF:              printf("[%d/%d] FATAL: Unexpected TPSS_PL_EOF\n",MT_TPSS,getpid());   return; break;
      case TPSS_PL_KEYWORD_MISMATCH: printf("[%d/%d] FATAL: TPSS_PL_KEYWORD_MISMATCH\n",MT_TPSS,getpid()); return; break;
      case TPSS_PL_OVERLONG_LINE:    printf("[%d/%d] FATAL: TPSS_PL_OVERLONG_LINE\n",MT_TPSS,getpid());    return; break;
      }

    sprintf(keyword,"OBS_STP_FREQ1[%d]",k); 
    while( (i=tpss_parse_line( fpsdf, keyword, data)) == TPSS_PL_BLANK_LINE ) { }
    switch (i) {
      case TPSS_PL_KEYWORD_MATCH:    
        printf("[%d/%d] %s='%s'",MT_TPSS,getpid(),keyword,data); 
        sscanf(data,"%ld",&(obs[nobs].OBS_STP_FREQ1[k]));
        printf("...converts to %ld\n",obs[nobs].OBS_STP_FREQ1[k]);
        if ( ( obs[nobs].OBS_STP_FREQ1[k]<219130984 ) || ( obs[nobs].OBS_STP_FREQ1[k]>1928352663 ) ) {   
          printf("[%d/%d] FATAL: OBS_STP_FREQ1[%d] out of range\n",MT_TPSS,getpid(),k);  
          return;
          }
        strcpy(data,"");   
        break;
      case TPSS_PL_EOF:              printf("[%d/%d] FATAL: Unexpected TPSS_PL_EOF\n",MT_TPSS,getpid());   return; break;
      case TPSS_PL_KEYWORD_MISMATCH: printf("[%d/%d] FATAL: TPSS_PL_KEYWORD_MISMATCH\n",MT_TPSS,getpid()); return; break;
      case TPSS_PL_OVERLONG_LINE:    printf("[%d/%d] FATAL: TPSS_PL_OVERLONG_LINE\n",MT_TPSS,getpid());    return; break;
      }

    sprintf(keyword,"OBS_STP_FREQ1+[%d]",k); strcpy(obs[nobs].OBS_STP_FREQ1p[k],"");
    while( (i=tpss_parse_line( fpsdf, keyword, data)) == TPSS_PL_BLANK_LINE ) { }
    switch (i) {
      case TPSS_PL_KEYWORD_MATCH:    
        printf("[%d/%d] %s='%s'\n",MT_TPSS,getpid(),keyword,data); 
        strcpy(obs[nobs].OBS_STP_FREQ1p[k],data);
        strcpy(data,"");   
        break;
      case TPSS_PL_EOF:                                                                                            break;
      case TPSS_PL_KEYWORD_MISMATCH: /* optional */                                                                break;
      case TPSS_PL_OVERLONG_LINE:    printf("[%d/%d] FATAL: TPSS_PL_OVERLONG_LINE\n",MT_TPSS,getpid());    return; break;
      }

    sprintf(keyword,"OBS_STP_FREQ2[%d]",k); 
    while( (i=tpss_parse_line( fpsdf, keyword, data)) == TPSS_PL_BLANK_LINE ) { }
    switch (i) {
      case TPSS_PL_KEYWORD_MATCH:    
        printf("[%d/%d] %s='%s'",MT_TPSS,getpid(),keyword,data); 
        sscanf(data,"%ld",&(obs[nobs].OBS_STP_FREQ2[k]));
        printf("...converts to %ld\n",obs[nobs].OBS_STP_FREQ2[k]);
        if ( ( obs[nobs].OBS_STP_FREQ2[k]<219130984 ) || ( obs[nobs].OBS_STP_FREQ2[k]>1928352663 ) ) {   
          printf("[%d/%d] FATAL: OBS_STP_FREQ2[%d] out of range\n",MT_TPSS,getpid(),k);  
          return;
          }
        strcpy(data,"");   
        break;
      case TPSS_PL_EOF:              printf("[%d/%d] FATAL: Unexpected TPSS_PL_EOF\n",MT_TPSS,getpid());   return; break;
      case TPSS_PL_KEYWORD_MISMATCH: printf("[%d/%d] FATAL: TPSS_PL_KEYWORD_MISMATCH\n",MT_TPSS,getpid()); return; break;
      case TPSS_PL_OVERLONG_LINE:    printf("[%d/%d] FATAL: TPSS_PL_OVERLONG_LINE\n",MT_TPSS,getpid());    return; break;
      }

    sprintf(keyword,"OBS_STP_FREQ2+[%d]",k); strcpy(obs[nobs].OBS_STP_FREQ2p[k],"");
    while( (i=tpss_parse_line( fpsdf, keyword, data)) == TPSS_PL_BLANK_LINE ) { }
    switch (i) {
      case TPSS_PL_KEYWORD_MATCH:    
        printf("[%d/%d] %s='%s'\n",MT_TPSS,getpid(),keyword,data); 
        strcpy(obs[nobs].OBS_STP_FREQ2p[k],data);
        strcpy(data,"");   
        break;
      case TPSS_PL_EOF:              printf("[%d/%d] FATAL: Unexpected TPSS_PL_EOF\n",MT_TPSS,getpid());   return; break;
      case TPSS_PL_KEYWORD_MISMATCH: /* optional */                                                                break;
      case TPSS_PL_OVERLONG_LINE:    printf("[%d/%d] FATAL: TPSS_PL_OVERLONG_LINE\n",MT_TPSS,getpid());    return; break;
      }

    sprintf(keyword,"OBS_STP_B[%d]",k); 
    while( (i=tpss_parse_line( fpsdf, keyword, data)) == TPSS_PL_BLANK_LINE ) { }
    switch (i) {
      case TPSS_PL_KEYWORD_MATCH:    
        printf("[%d/%d] %s='%s'",MT_TPSS,getpid(),keyword,data); 
        if (!(obs[nobs].OBS_STP_B[k] = LWA_getbeamtype(data))) {
          printf("[%d/%d] FATAL: Invalid OBS_STP_B[%d]\n",MT_TPSS,getpid(),k);   
          return;
          } 
        LWA_saybeamtype( obs[nobs].OBS_STP_B[k], mode_string );
        printf("...converts to '%s'\n",mode_string); 
        strcpy(data,"");   
        break;
      case TPSS_PL_EOF:              printf("[%d/%d] FATAL: Unexpected TPSS_PL_EOF\n",MT_TPSS,getpid());   return; break;
      case TPSS_PL_KEYWORD_MISMATCH: printf("[%d/%d] FATAL: TPSS_PL_KEYWORD_MISMATCH\n",MT_TPSS,getpid()); return; break;
      case TPSS_PL_OVERLONG_LINE:    printf("[%d/%d] FATAL: TPSS_PL_OVERLONG_LINE\n",MT_TPSS,getpid());    return; break;
      }

    if (obs[nobs].OBS_STP_B[k]==LWA_BT_SPEC_DELAYS_GAINS) {

      for (p=1;p<=520;p++) {

        sprintf(keyword,"OBS_BEAM_DELAY[%d][%d]",k,p); 
        while( (i=tpss_parse_line( fpsdf, keyword, data)) == TPSS_PL_BLANK_LINE ) { }
        switch (i) {
          case TPSS_PL_KEYWORD_MATCH:    
            printf("[%d/%d] %s='%s'",MT_TPSS,getpid(),keyword,data); 
            sscanf(data,"%hu",&(obs[nobs].OBS_BEAM_DELAY[k][p])); 
            printf("...converts to %hu\n",obs[nobs].OBS_BEAM_DELAY[k][p]); 
            if (obs[nobs].OBS_BEAM_DELAY[k][p]>MAX_BEAM_DELAY) {
              printf("[%d/%d] FATAL: Invalid OBS_BEAM_DELAY[%d]\n",MT_TPSS,getpid(),k); 
              }
            strcpy(data,"");   
            break;
          case TPSS_PL_EOF:              printf("[%d/%d] FATAL: Unexpected TPSS_PL_EOF\n",MT_TPSS,getpid());   return; break;
          case TPSS_PL_KEYWORD_MISMATCH: printf("[%d/%d] FATAL: TPSS_PL_KEYWORD_MISMATCH\n",MT_TPSS,getpid()); return; break;
          case TPSS_PL_OVERLONG_LINE:    printf("[%d/%d] FATAL: TPSS_PL_OVERLONG_LINE\n",MT_TPSS,getpid());    return; break;
          }

        } /* for p */

      for (p=1;p<=260;p++) {
      for (q=1;q<=2;q++) {
      for (r=1;r<=2;r++) {

        sprintf(keyword,"OBS_BEAM_GAIN[%d][%d][%d][%d]",k,p,q,r); 
        while( (i=tpss_parse_line( fpsdf, keyword, data)) == TPSS_PL_BLANK_LINE ) { }
        switch (i) {
          case TPSS_PL_KEYWORD_MATCH:    
            printf("[%d/%d] %s='%s'",MT_TPSS,getpid(),keyword,data); 
            sscanf(data,"%hd",&(obs[nobs].OBS_BEAM_DELAY[k][p])); 
            printf("...converts to %hd\n",obs[nobs].OBS_BEAM_GAIN[k][p][q][r]); 
            //if (obs[nobs].OBS_BEAM_DELAY[k][p][q][r]>MAX_BEAM_DELAY) {
            // printf("[%d/%d] FATAL: Invalid OBS_BEAM_DELAY[%d]\n",MT_TPSS,getpid(),k); 
            //  }
            strcpy(data,"");   
            break;
          case TPSS_PL_EOF:              printf("[%d/%d] FATAL: Unexpected TPSS_PL_EOF\n",MT_TPSS,getpid());   return; break;
          case TPSS_PL_KEYWORD_MISMATCH: printf("[%d/%d] FATAL: TPSS_PL_KEYWORD_MISMATCH\n",MT_TPSS,getpid()); return; break;
          case TPSS_PL_OVERLONG_LINE:    printf("[%d/%d] FATAL: TPSS_PL_OVERLONG_LINE\n",MT_TPSS,getpid());    return; break;
          }

        } /* for r */
        } /* for q */
        } /* for p */

      } /*  if (obs[nobs].OBS_STP_B[k]==LWA_BT_SPEC_DELAYS_GAINS) */




    } /* for k */
  
